import 'package:flutter_test/flutter_test.dart';
import 'package:hello1234/hello1234.dart';
import 'package:hello1234/hello1234_platform_interface.dart';
import 'package:hello1234/hello1234_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockHello1234Platform
    with MockPlatformInterfaceMixin
    implements Hello1234Platform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final Hello1234Platform initialPlatform = Hello1234Platform.instance;

  test('$MethodChannelHello1234 is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelHello1234>());
  });

  test('getPlatformVersion', () async {
    Hello1234 hello1234Plugin = Hello1234();
    MockHello1234Platform fakePlatform = MockHello1234Platform();
    Hello1234Platform.instance = fakePlatform;

    expect(await hello1234Plugin.getPlatformVersion(), '42');
  });
}
